using Exferia_Aplicacion.General;
using Exferia_General;
using Exferia_KairosPRO._1_Modelos;
using Exferia_KairosPRO._1_Modelos.Herencia.Capas;
using Exferia_KairosPRO_EF;
using System;
using System.Collections.Generic;
using System.Data.SqlClient;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using static Exferia_Aplicacion.General.Enumerados;

namespace Exferia_KairosPRO._2_Datos
{
    public class KRS_SolicitudesAusenciasProgramadas_Adjuntos_Datos : ABS_Datos
    {
        #region Listado
        public override List<dynamic> Obtener_Listado(List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            throw new NotImplementedException();
        }
        public override dynamic Obtener_RegistroListado(List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo, long _lng_id, List<long> _lst_id)
        {
            throw new NotImplementedException();
        }
        protected override void ConsultaRellenar_Listado(KairosProEntities _dbcontext, List<string> _lst_CamposConRelacionABuscar, long _lng_id, List<long> _lst_id, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        { }
        #endregion

        #region Listado Secundario
        public override List<dynamic> Obtener_Listado_Secundario(List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            return null;
        }
        public override dynamic Obtener_RegistroListado_Secundario(List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo, long _lng_id, List<long> _lst_id)
        {
            return null;
        }
        protected override void ConsultaRellenar_Listado_Secundario(KairosProEntities _dbcontext, List<string> _lst_CamposConRelacionABuscar, long _lng_id, List<long> _lst_id, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {

        }
        #endregion

        #region F3
        public override dynamic Obtener_F3(string _str_filtro, string _str_CampoBusqueda, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            throw new NotImplementedException();
        }
        public override dynamic Obtener_F3_PorId(long _lng_id, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            throw new NotImplementedException();
        }
        protected override void ConsultaRellenar_F3(KairosProEntities _dbcontext, string _str_CampoBusqueda, string _str_Filtro, long _lng_id, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {

        }
        #endregion

        #region Obtener
        public override dynamic Obtener(long _lng_id)
        {
            throw new NotImplementedException();
        }
        public override dynamic Obtener_Registro_PorCampo(string _str_CampoBusqueda, string _str_Filtro)
        {
            throw new NotImplementedException();
        }

        #region Cantidad Adjuntos
        public List<INTERNO_AUX_SolicitudAdjuntosTotal_Modelo> Obtener_CantidadAdjuntos_Por_SolicitudAusenciaProgramada(List<long> _lst_idSolicitudAusenciaProgramada)
        {
            KairosProEntities obj_KairosProEntities = null;
            List<INTERNO_AUX_SolicitudAdjuntosTotal_Modelo> lst_INTERNO_AUX_SolicitudAdjuntosTotal_Modelo = null;
            try
            {
                //Conexion
                obj_KairosProEntities = new KairosProEntities();
                obj_KairosProEntities.Configuration.LazyLoadingEnabled = false;

                if (_lst_idSolicitudAusenciaProgramada != null && _lst_idSolicitudAusenciaProgramada.Count > 0)
                {
                    List<SqlParameter> lst_Parametros = new List<SqlParameter>();

                    string str_Filtros_IDS = Funciones.Formar_ContenidoIN_ParaConsultaWhere(_lst_idSolicitudAusenciaProgramada);


                    //Consulta
                    string str_SQL =    " SELECT " +
                                           nameof(INTERNO_AUX_SolicitudAdjuntosTotal_Modelo.IdSolicitudAusenciaProgramada) + "=" + nameof(KRS_SolicitudesAusenciasProgramadas_Adjuntos.idSolicitudAusenciaProgramada) + "," +
                                           nameof(INTERNO_AUX_SolicitudAdjuntosTotal_Modelo.Total) + "=" + " count(" + nameof(KRS_SolicitudesAusenciasProgramadas_Adjuntos.id) + ") " +
                                        " FROM " + nameof(KRS_SolicitudesAusenciasProgramadas_Adjuntos) + 
                                        //WHERE
                                        " WHERE " +
                                            nameof(KRS_SolicitudesAusenciasProgramadas_Adjuntos) + "." + nameof(KRS_SolicitudesAusenciasProgramadas_Adjuntos.fechaBorrado) + " is null and " +
                                            nameof(KRS_SolicitudesAusenciasProgramadas_Adjuntos) + "." + nameof(KRS_SolicitudesAusenciasProgramadas_Adjuntos.codigoCliente) + "=@codigoCliente and " +
                                            nameof(KRS_SolicitudesAusenciasProgramadas_Adjuntos) + "." + nameof(KRS_SolicitudesAusenciasProgramadas_Adjuntos.idSolicitudAusenciaProgramada) + " in (" + str_Filtros_IDS + ") " +
                                        " GROUP BY " +
                                               nameof(KRS_SolicitudesAusenciasProgramadas_Adjuntos.idSolicitudAusenciaProgramada);

                    //Parametros
                    lst_Parametros.Add(new SqlParameter("@codigoCliente", Variables.G_LNG_IDCLIENTE_LICENCIAVALIDADO));
                    object[] arr_Parametros = lst_Parametros.ToArray();

                    //Rellenar el modelo
                    lst_INTERNO_AUX_SolicitudAdjuntosTotal_Modelo = obj_KairosProEntities.Database.SqlQuery<INTERNO_AUX_SolicitudAdjuntosTotal_Modelo>(str_SQL, arr_Parametros).ToList();
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(KRS_SolicitudesAusenciasProgramadas_Adjuntos_Datos) + "/" + nameof(Obtener_CantidadAdjuntos_Por_SolicitudAusenciaProgramada), true);
            }
            finally
            {
                obj_KairosProEntities.Database.Connection.Close();
                obj_KairosProEntities.Dispose();
            }

            return lst_INTERNO_AUX_SolicitudAdjuntosTotal_Modelo;
        }
        public INTERNO_AUX_SolicitudAdjuntosTotal_Modelo Obtener_CantidadAdjuntos_Por_SolicitudAusenciaProgramada(long _lng_idSolicitudAusenciaProgramada)
        {
            KairosProEntities obj_KairosProEntities = null;
            INTERNO_AUX_SolicitudAdjuntosTotal_Modelo mdl_INTERNO_AUX_SolicitudAdjuntosTotal_Modelo = null;
            try
            {
                //Conexion
                obj_KairosProEntities = new KairosProEntities();
                obj_KairosProEntities.Configuration.LazyLoadingEnabled = false;

                //Consulta
                string str_SQL = " SELECT " +
                                        nameof(INTERNO_AUX_SolicitudAdjuntosTotal_Modelo.IdSolicitudAusenciaProgramada) + "=" + nameof(KRS_SolicitudesAusenciasProgramadas_Adjuntos.idSolicitudAusenciaProgramada) + "," +
                                        nameof(INTERNO_AUX_SolicitudAdjuntosTotal_Modelo.Total) + "=" + " count(" + nameof(KRS_SolicitudesAusenciasProgramadas_Adjuntos.id) + ") " +
                                    " FROM " + nameof(KRS_SolicitudesAusenciasProgramadas_Adjuntos) +
                                    //WHERE
                                    " WHERE " +
                                        nameof(KRS_SolicitudesAusenciasProgramadas_Adjuntos) + "." + nameof(KRS_SolicitudesAusenciasProgramadas_Adjuntos.fechaBorrado) + " is null and " +
                                        nameof(KRS_SolicitudesAusenciasProgramadas_Adjuntos) + "." + nameof(KRS_SolicitudesAusenciasProgramadas_Adjuntos.codigoCliente) + "=@codigoCliente and " +
                                        nameof(KRS_SolicitudesAusenciasProgramadas_Adjuntos) + "." + nameof(KRS_SolicitudesAusenciasProgramadas_Adjuntos.idSolicitudAusenciaProgramada) + "=@idSolicitudAusenciaProgramada  " +
                                    " GROUP BY " +
                                            nameof(KRS_SolicitudesAusenciasProgramadas_Adjuntos.idSolicitudAusenciaProgramada);

                //Parametros
                List<SqlParameter> lst_Parametros = new List<SqlParameter>();
                lst_Parametros.Add(new SqlParameter("@codigoCliente", Variables.G_LNG_IDCLIENTE_LICENCIAVALIDADO));
                lst_Parametros.Add(new SqlParameter("@idSolicitudAusenciaProgramada", _lng_idSolicitudAusenciaProgramada));
                object[] arr_Parametros = lst_Parametros.ToArray();

                //Rellenar el modelo
                mdl_INTERNO_AUX_SolicitudAdjuntosTotal_Modelo = obj_KairosProEntities.Database.SqlQuery<INTERNO_AUX_SolicitudAdjuntosTotal_Modelo>(str_SQL, arr_Parametros).FirstOrDefault();
                
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(KRS_SolicitudesAusenciasProgramadas_Adjuntos_Datos) + "/" + nameof(Obtener_CantidadAdjuntos_Por_SolicitudAusenciaProgramada), true);
            }
            finally
            {
                obj_KairosProEntities.Database.Connection.Close();
                obj_KairosProEntities.Dispose();
            }

            return mdl_INTERNO_AUX_SolicitudAdjuntosTotal_Modelo;
        }

        #endregion
        #endregion

        #region MODELOS

        #region Modelo Simple
        private KRS_SolicitudesAusenciasProgramadas_Adjuntos g_mdl_KRS_SolicitudesAusenciasProgramadas_Adjuntos = null;
        public KRS_SolicitudesAusenciasProgramadas_Adjuntos Obtener_Modelo_Por_Id(long _lng_id, long _lng_CodigoCliente)
        {
            try
            {
                string str_SQL = Obtener_Consulta_Modelo() +
                                  //WHERE
                                  " WHERE " +
                                        nameof(KRS_SolicitudesAusenciasProgramadas_Adjuntos) + "." + nameof(KRS_SolicitudesAusenciasProgramadas_Adjuntos.id) + "=@id and " +
                                        nameof(KRS_SolicitudesAusenciasProgramadas_Adjuntos) + "." + nameof(KRS_SolicitudesAusenciasProgramadas_Adjuntos.codigoCliente) + "=@codigoCliente ";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@id",  _lng_id),
                     new SqlParameter("@codigoCliente",  _lng_CodigoCliente)
                };

                //Ejecutar y rellenar el modelo
                Ejecutar_Consulta_Modelo(str_SQL,
                                            arr_Parametros);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(KRS_SolicitudesAusenciasProgramadas_Adjuntos_Datos) + "/" + nameof(Obtener_Modelo_Por_Id), true);
            }

            return g_mdl_KRS_SolicitudesAusenciasProgramadas_Adjuntos;
        }

        private void Ejecutar_Consulta_Modelo(string _str_SQL, object[] _arr_Parametros)
        {
            KairosProEntities obj_KairosProEntities = null;

            try
            {
                //Conexion
                obj_KairosProEntities = new KairosProEntities();
                obj_KairosProEntities.Configuration.LazyLoadingEnabled = false;


                //Rellenar el Modelo
                g_mdl_KRS_SolicitudesAusenciasProgramadas_Adjuntos = obj_KairosProEntities.Database.SqlQuery<KRS_SolicitudesAusenciasProgramadas_Adjuntos>(_str_SQL, _arr_Parametros).FirstOrDefault();
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(KRS_SolicitudesAusenciasProgramadas_Adjuntos_Datos) + "/" + nameof(Ejecutar_Consulta_Modelo), true);
            }
            finally
            {
                obj_KairosProEntities.Database.Connection.Close();
                obj_KairosProEntities.Dispose();
            }
        }

        #endregion

        #region Modelo Listado
        private List<KRS_SolicitudesAusenciasProgramadas_Adjuntos> g_lst_KRS_SolicitudesAusenciasProgramadas_Adjuntos = null;

        public List<KRS_SolicitudesAusenciasProgramadas_Adjuntos> Obtener_ModeloListado_Por_Ids(List<long> _lst_Ids)
        {
            try
            {
                if (_lst_Ids != null && _lst_Ids.Count > 0)
                {
                    List<SqlParameter> lst_Parametros = new List<SqlParameter>();

                    string str_Filtros_IDS = Funciones.Formar_ContenidoIN_ParaConsultaWhere(nameof(KRS_SolicitudesAusenciasProgramadas_Adjuntos),
                                                                                           nameof(KRS_SolicitudesAusenciasProgramadas_Adjuntos.id),
                                                                                           G_ENUM_FORMARCONTENIDOIN_CONDICIONANTES.NADA,
                                                                                           _lst_Ids);


                    //Consulta
                    string str_SQL = Obtener_Consulta_Modelo() +
                                       //WHERE
                                       " WHERE " +
                                            nameof(KRS_SolicitudesAusenciasProgramadas_Adjuntos) + "." + nameof(KRS_SolicitudesAusenciasProgramadas_Adjuntos.codigoCliente) + "=@codigoCliente and " +
                                            str_Filtros_IDS;

                    //Parametros
                    lst_Parametros.Add(new SqlParameter("@codigoCliente", Variables.G_LNG_IDCLIENTE_LICENCIAVALIDADO));
                    object[] arr_Parametros = lst_Parametros.ToArray();

                    //Ejecutar y rellenar el listado
                    Ejecutar_Consulta_Modelo_Listado(str_SQL,
                                                     arr_Parametros);
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(KRS_SolicitudesAusenciasProgramadas_Adjuntos_Datos) + "/" + nameof(Obtener_ModeloListado_Por_Ids), true);
            }

            return g_lst_KRS_SolicitudesAusenciasProgramadas_Adjuntos;
        }
        public List<KRS_SolicitudesAusenciasProgramadas_Adjuntos> Obtener_ModeloListado_Por_IdSolicitudAusenciaProgramada(long _lng_idSolicitudAusenciaProgramada)
        {
            try
            {
                //Consulta
                string str_SQL = Obtener_Consulta_Modelo() +
                                    //WHERE
                                    " WHERE " +
                                        nameof(KRS_SolicitudesAusenciasProgramadas_Adjuntos) + "." + nameof(KRS_SolicitudesAusenciasProgramadas_Adjuntos.codigoCliente) + "=@codigoCliente and " +
                                        nameof(KRS_SolicitudesAusenciasProgramadas_Adjuntos) + "." + nameof(KRS_SolicitudesAusenciasProgramadas_Adjuntos.idSolicitudAusenciaProgramada) + "=@idSolicitudAusenciaProgramada ";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@codigoCliente",  Variables.G_LNG_IDCLIENTE_LICENCIAVALIDADO),
                     new SqlParameter("@idSolicitudAusenciaProgramada",  _lng_idSolicitudAusenciaProgramada)
                };

                //Ejecutar y rellenar el listado
                Ejecutar_Consulta_Modelo_Listado(str_SQL,
                                                    arr_Parametros);
                
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(KRS_SolicitudesAusenciasProgramadas_Adjuntos_Datos) + "/" + nameof(Obtener_ModeloListado_Por_IdSolicitudAusenciaProgramada), true);
            }

            return g_lst_KRS_SolicitudesAusenciasProgramadas_Adjuntos;
        }

        #region Ejecutar Consulta
        private void Ejecutar_Consulta_Modelo_Listado(string _str_SQL,
                                                    object[] _arr_Parametros)
        {
            KairosProEntities obj_KairosProEntities = null;
            try
            {
                //Conexion
                obj_KairosProEntities = new KairosProEntities();
                obj_KairosProEntities.Configuration.LazyLoadingEnabled = false;


                //Rellenar el modelo
                g_lst_KRS_SolicitudesAusenciasProgramadas_Adjuntos = obj_KairosProEntities.Database.SqlQuery<KRS_SolicitudesAusenciasProgramadas_Adjuntos>(_str_SQL, _arr_Parametros).ToList();
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(KRS_SolicitudesAusenciasProgramadas_Adjuntos_Datos) + "/" + nameof(Ejecutar_Consulta_Modelo_Listado), true);
            }
            finally
            {
                obj_KairosProEntities.Database.Connection.Close();
                obj_KairosProEntities.Dispose();
            }
        }

        #endregion

        #endregion

        private string Obtener_Consulta_Modelo()
        {
            return
                " SELECT " +
                    nameof(KRS_SolicitudesAusenciasProgramadas_Adjuntos) + "." + nameof(KRS_SolicitudesAusenciasProgramadas_Adjuntos.id) + " , " +
                    nameof(KRS_SolicitudesAusenciasProgramadas_Adjuntos) + "." + nameof(KRS_SolicitudesAusenciasProgramadas_Adjuntos.codigoCliente) + " , " +
                    nameof(KRS_SolicitudesAusenciasProgramadas_Adjuntos) + "." + nameof(KRS_SolicitudesAusenciasProgramadas_Adjuntos.idSolicitudAusenciaProgramada) + " , " +
                    nameof(KRS_SolicitudesAusenciasProgramadas_Adjuntos) + "." + nameof(KRS_SolicitudesAusenciasProgramadas_Adjuntos.fichero) + " , " +
                    nameof(KRS_SolicitudesAusenciasProgramadas_Adjuntos) + "." + nameof(KRS_SolicitudesAusenciasProgramadas_Adjuntos.descripcion) + " , " +
                    nameof(KRS_SolicitudesAusenciasProgramadas_Adjuntos) + "." + nameof(KRS_SolicitudesAusenciasProgramadas_Adjuntos.fechaBorrado) + " , " +
                    nameof(KRS_SolicitudesAusenciasProgramadas_Adjuntos) + "." + nameof(KRS_SolicitudesAusenciasProgramadas_Adjuntos.extensionFichero) +
                " FROM " + nameof(KRS_SolicitudesAusenciasProgramadas_Adjuntos);
        }
        #endregion

        #region Grabar
        public override INTERNO_ValorDevuelto_Modelo Grabar(object _mdl_obj)
        {
            KairosProEntities obj_KairosProEntities = null;

            INTERNO_ValorDevuelto_Modelo mdl_INTERNO_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = true;

            try
            {
                obj_KairosProEntities = new KairosProEntities();
                obj_KairosProEntities.Configuration.LazyLoadingEnabled = false;

                KRS_SolicitudesAusenciasProgramadas_Adjuntos mdl_KRS_SolicitudesAusenciasProgramadas_Adjuntos_AGrabar = (KRS_SolicitudesAusenciasProgramadas_Adjuntos)_mdl_obj;
                KRS_SolicitudesAusenciasProgramadas_Adjuntos mdl_KRS_SolicitudesAusenciasProgramadas_Adjuntos_DatosViejos = new KRS_SolicitudesAusenciasProgramadas_Adjuntos();

                KRS_SolicitudesAusenciasProgramadas_Adjuntos mdl_KRS_SolicitudesAusenciasProgramadas_Adjuntos_Final = Obtener_Modelo_Por_Id(mdl_KRS_SolicitudesAusenciasProgramadas_Adjuntos_AGrabar.id, mdl_KRS_SolicitudesAusenciasProgramadas_Adjuntos_AGrabar.codigoCliente);

                if (mdl_KRS_SolicitudesAusenciasProgramadas_Adjuntos_Final != null )
                {
                    //Tipo de Accion que se va a realizar
                    mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = G_ENUM_TIPOACCION.INT_MODIFICAR;

                    //Datos viejos para la trazabilidad
                    Funciones.CopiarPropiedadesObjetos(mdl_KRS_SolicitudesAusenciasProgramadas_Adjuntos_Final, mdl_KRS_SolicitudesAusenciasProgramadas_Adjuntos_DatosViejos, false, false);

                    //Cargar los Datos Nuevos para la trazabilidad
                    Funciones.CopiarPropiedadesObjetos(mdl_KRS_SolicitudesAusenciasProgramadas_Adjuntos_AGrabar, mdl_KRS_SolicitudesAusenciasProgramadas_Adjuntos_Final, false, false);

                    #region Update
                    string str_SQL_Update = " UPDATE " + nameof(KRS_SolicitudesAusenciasProgramadas_Adjuntos) +
                                           " SET " +
                                                nameof(KRS_SolicitudesAusenciasProgramadas_Adjuntos.codigoCliente) + "=@codigoCliente," +
                                                nameof(KRS_SolicitudesAusenciasProgramadas_Adjuntos.idSolicitudAusenciaProgramada) + "=@idSolicitudAusenciaProgramada," +
                                                nameof(KRS_SolicitudesAusenciasProgramadas_Adjuntos.fichero) + "=@fichero," +
                                                nameof(KRS_SolicitudesAusenciasProgramadas_Adjuntos.descripcion) + "=@descripcion," +
                                                nameof(KRS_SolicitudesAusenciasProgramadas_Adjuntos.fechaBorrado) + "=@fechaBorrado," +
                                                nameof(KRS_SolicitudesAusenciasProgramadas_Adjuntos.extensionFichero) + "=@extensionFichero" +
                                           " WHERE " +
                                               nameof(KRS_SolicitudesAusenciasProgramadas_Adjuntos.id) + "=@id ";

                    //Parametros
                    object[] arr_Parametros_Update = new object[]
                    {
                        new SqlParameter("@codigoCliente", mdl_KRS_SolicitudesAusenciasProgramadas_Adjuntos_Final.codigoCliente),
                        new SqlParameter("@idSolicitudAusenciaProgramada", mdl_KRS_SolicitudesAusenciasProgramadas_Adjuntos_Final.idSolicitudAusenciaProgramada),
                        new SqlParameter("@fichero", mdl_KRS_SolicitudesAusenciasProgramadas_Adjuntos_Final.fichero),
                        mdl_KRS_SolicitudesAusenciasProgramadas_Adjuntos_Final.descripcion != null
                            ?   new SqlParameter("@descripcion", mdl_KRS_SolicitudesAusenciasProgramadas_Adjuntos_Final.descripcion)
                            :   new SqlParameter("@descripcion",  DBNull.Value),
                        mdl_KRS_SolicitudesAusenciasProgramadas_Adjuntos_Final.fechaBorrado != null
                            ?   new SqlParameter("@fechaBorrado", mdl_KRS_SolicitudesAusenciasProgramadas_Adjuntos_Final.fechaBorrado.Value)
                            :   new SqlParameter("@fechaBorrado",  DBNull.Value),
                        mdl_KRS_SolicitudesAusenciasProgramadas_Adjuntos_Final.extensionFichero != null
                            ?   new SqlParameter("@extensionFichero", mdl_KRS_SolicitudesAusenciasProgramadas_Adjuntos_Final.extensionFichero)
                            :   new SqlParameter("@extensionFichero",  DBNull.Value),
                        new SqlParameter("@id",  mdl_KRS_SolicitudesAusenciasProgramadas_Adjuntos_Final.id)
                    };
                    #endregion

                    //Update
                    obj_KairosProEntities.Database.ExecuteSqlCommand(str_SQL_Update, arr_Parametros_Update);

                    //Id de la tabla
                    mdl_INTERNO_ValorDevuelto_Modelo.Id = mdl_KRS_SolicitudesAusenciasProgramadas_Adjuntos_Final.id;
                }
                else
                {
                    mdl_KRS_SolicitudesAusenciasProgramadas_Adjuntos_Final = new KRS_SolicitudesAusenciasProgramadas_Adjuntos();

                    //Tipo de Accion que se va a realizar
                    mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = G_ENUM_TIPOACCION.INT_INSERTAR;

                    //Cargar los datos del Modelo
                    Funciones.CopiarPropiedadesObjetos(mdl_KRS_SolicitudesAusenciasProgramadas_Adjuntos_AGrabar, mdl_KRS_SolicitudesAusenciasProgramadas_Adjuntos_Final, false, false);

                    #region INSERT
                    string str_SQL_Insert = " INSERT INTO " + nameof(KRS_SolicitudesAusenciasProgramadas_Adjuntos) +
                                               " (" +
                                                        nameof(KRS_SolicitudesAusenciasProgramadas_Adjuntos.codigoCliente) + "," +
                                                        nameof(KRS_SolicitudesAusenciasProgramadas_Adjuntos.idSolicitudAusenciaProgramada) + "," +
                                                        nameof(KRS_SolicitudesAusenciasProgramadas_Adjuntos.fichero) + "," +
                                                        nameof(KRS_SolicitudesAusenciasProgramadas_Adjuntos.descripcion) + "," +
                                                        nameof(KRS_SolicitudesAusenciasProgramadas_Adjuntos.fechaBorrado) + "," +
                                                         nameof(KRS_SolicitudesAusenciasProgramadas_Adjuntos.extensionFichero) +
                                               " ) " +
                                               " OUTPUT INSERTED." + nameof(KRS_SolicitudesAusenciasProgramadas_Adjuntos.id) +
                                               " VALUES " +
                                               " ( " +
                                                    "@codigoCliente," +
                                                    "@idSolicitudAusenciaProgramada," +
                                                    "@fichero," +
                                                    "@descripcion," +
                                                    "@fechaBorrado," +
                                                    "@extensionFichero" +
                                               " ) ";

                    //Parametros
                    object[] arr_Parametros_Insert = new object[]
                    {
                        new SqlParameter("@codigoCliente", mdl_KRS_SolicitudesAusenciasProgramadas_Adjuntos_Final.codigoCliente),
                        new SqlParameter("@idSolicitudAusenciaProgramada", mdl_KRS_SolicitudesAusenciasProgramadas_Adjuntos_Final.idSolicitudAusenciaProgramada),
                        new SqlParameter("@fichero", mdl_KRS_SolicitudesAusenciasProgramadas_Adjuntos_Final.fichero),
                        mdl_KRS_SolicitudesAusenciasProgramadas_Adjuntos_Final.descripcion != null
                            ?   new SqlParameter("@descripcion", mdl_KRS_SolicitudesAusenciasProgramadas_Adjuntos_Final.descripcion)
                            :   new SqlParameter("@descripcion",  DBNull.Value),
                        mdl_KRS_SolicitudesAusenciasProgramadas_Adjuntos_Final.fechaBorrado != null
                            ?   new SqlParameter("@fechaBorrado", mdl_KRS_SolicitudesAusenciasProgramadas_Adjuntos_Final.fechaBorrado.Value)
                            :   new SqlParameter("@fechaBorrado",  DBNull.Value),
                         mdl_KRS_SolicitudesAusenciasProgramadas_Adjuntos_Final.extensionFichero != null
                            ?   new SqlParameter("@extensionFichero", mdl_KRS_SolicitudesAusenciasProgramadas_Adjuntos_Final.extensionFichero)
                            :   new SqlParameter("@extensionFichero",  DBNull.Value),
                    };
                    #endregion

                    //Id de la tabla
                    mdl_INTERNO_ValorDevuelto_Modelo.Id = obj_KairosProEntities.Database.SqlQuery<long>(str_SQL_Insert, arr_Parametros_Insert).Single();
                }

                //Grabar Trazabilidad
                USR_Trazabilidad_Datos.Grabar_Trazabilidad(typeof(KRS_SolicitudesAusenciasProgramadas_Adjuntos), null, mdl_KRS_SolicitudesAusenciasProgramadas_Adjuntos_Final, mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion, obj_KairosProEntities);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(KRS_SolicitudesAusenciasProgramadas_Adjuntos_Datos) + "/" + nameof(Grabar), true);
            }
            finally
            {
                //Cerramos la conexion
                obj_KairosProEntities.Database.Connection.Close();
                obj_KairosProEntities.Dispose();
            }

            return mdl_INTERNO_ValorDevuelto_Modelo;
        }
        #endregion

        #region Borrar
        public override INTERNO_ValorDevuelto_Modelo Borrar(long _lng_id)
        {
            return null;
        }
        public override INTERNO_ValorDevuelto_Modelo Borrar(long _lng_id, long _lng_idAuxiliar)
        {
            throw new NotImplementedException();
        }
        public override INTERNO_ValorDevuelto_Modelo Borrar(object _mdl_obj)
        {
            KairosProEntities obj_KairosProEntities = null;

            INTERNO_ValorDevuelto_Modelo mdl_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_ValorDevuelto_Modelo.TodoCorrecto = true;

            try
            {
                obj_KairosProEntities = new KairosProEntities();
                obj_KairosProEntities.Configuration.LazyLoadingEnabled = false;

                List<long> lst_id= (List<long>)_mdl_obj;

                if (lst_id != null && lst_id.Count > 0)
                {
                    List<SqlParameter> lst_Parametros = new List<SqlParameter>();

                    string str_Filtro_IDS = Funciones.Formar_ContenidoIN_ParaConsultaWhere(lst_id);

                    string str_SQL_Delete = " DELETE FROM " + nameof(KRS_SolicitudesAusenciasProgramadas_Adjuntos) +
                                            " WHERE " + nameof(KRS_SolicitudesAusenciasProgramadas_Adjuntos.codigoCliente) + " =@codigoCliente  AND " +
                                                        nameof(KRS_SolicitudesAusenciasProgramadas_Adjuntos.id) + " in (" + str_Filtro_IDS + ")";

                    //Parametros
                    lst_Parametros.Add(new SqlParameter("@codigoCliente", Variables.G_LNG_IDCLIENTE_LICENCIAVALIDADO));
                    object[] arr_Parametros_Delete = lst_Parametros.ToArray();

                    //Delete
                    obj_KairosProEntities.Database.ExecuteSqlCommand(str_SQL_Delete, arr_Parametros_Delete);
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                Control_Errores.Errores_Log("", ex, nameof(KRS_SolicitudesAusenciasProgramadas_Adjuntos_Datos) + "/" + nameof(Borrar));
                mdl_ValorDevuelto_Modelo.TodoCorrecto = false;
            }
            finally
            {
                
                obj_KairosProEntities.Database.Connection.Close();
                obj_KairosProEntities.Dispose();
            }

            return mdl_ValorDevuelto_Modelo;
        }
        #endregion
    }
}
